from PySide2.QtGui import QTransform
from axipy import Pnt


class Affine:
    def __init__(self,points_base,points_tab):
        self.__points_base=points_base
        self.__points_tab=points_tab
        self.__isValid=False
        self.__calc()
    def __calc(self):
        self._tx=self.__calcCoefficient(self.__points_tab[0],self.__points_tab[1],self.__points_tab[2],self.__points_base[0].x,self.__points_base[1].x,self.__points_base[2].x)
        self._ty = self.__calcCoefficient(self.__points_tab[0], self.__points_tab[1], self.__points_tab[2],
                                    self.__points_base[0].y, self.__points_base[1].y, self.__points_base[2].y)

    def __calcCoefficient(self,pnt1s:Pnt,pnt2s:Pnt,pnt3s:Pnt,v1o,v2o,v3o):
        d1_2x=pnt1s.x-pnt2s.x
        d1_2y=pnt1s.y-pnt2s.y
        d1_3x=pnt1s.x-pnt3s.x
        d1_3y = pnt1s.y - pnt3s.y
        t1_2=v1o-v2o
        t1_3=v1o-v3o
        if d1_3y==0:
            if d1_3x==0:
                self.__isValid=False
                return
            a=t1_3/d1_3x
            if d1_2y==0:
                self.__isValid = False
                return
        else:
            a6=d1_2x-d1_3x*d1_2y/d1_3y
            t6=t1_2-t1_3*d1_2y/d1_3y
            if a6==0:
                self.__isValid=False
                return
            a=t6/a6
        if d1_2y==0:
            b=(t1_3-d1_3x*a)/d1_3y
        else:
            b=(t1_2-d1_2x*a)/d1_2y
        c=v1o-a*pnt1s.x-b*pnt1s.y
        self.__isValid = True

        return a,b,c
    def getTransform(self):
        #qt_trans=QTransform(self._tx[0],self._ty[0],0,self._tx[1],self._ty[1],0,self._tx[2],self._ty[2],0)
        #qt_trans.setMatrix(self._tx[0],self._ty[0],1,self._tx[1],self._ty[1],1,self._tx[2],self._ty[2],1)
        qt_trans=QTransform(self._tx[0],self._ty[0], self._tx[1],self._ty[1], self._tx[2],self._ty[2])
        return qt_trans

