from PySide2.QtCore import QObject
from axipy import CoordSystem, provider_manager, attr, MapView, Layer, Style, Point, Feature, data_manager

from RegisterVector.ui.add.maptool import moveLayerTo
from RegisterVector.ui.add.uiPoints import PointsCntl


class TempRegPoint(QObject):
    def __init__(self,name,points_cntl:PointsCntl,cs:CoordSystem,style_pnt=None):
        super().__init__()
        self.__name=name
        self.__points=points_cntl
        self.__cs=cs
        self.__initTab()
        self.__ft_points={}
        self.__def_style=style_pnt
        if style_pnt is None:
            self.__def_style=Style.from_mapinfo('Symbol (50, 16711680, 17, "Map Symbols", 1, 0)')
    def __initTab(self):
        definition = {
            'src': '',
            'schema': attr.schema(
                attr.string('id'),
                coordsystem=self.__cs,

            ),

        }
        self.__table = provider_manager.create(definition)
        self.__table.name = self.__name
    @property
    def table(self):
        return self.__table
    def setPointXY(self,x:float,y:float):
        self.__points.setXY(x,y)
        name_point="point_"+str(self.__points.activeId)
        new_point = Point(x, y, self.__cs)
        new_ft_point = Feature({'id': self.__points.activeId}, geometry=new_point, style=self.__def_style)
        if name_point in self.__ft_points.keys():
            ''' Update point'''
            sql_delete="Delete From "+self.__table.name+" where id="+str(self.__points.activeId)
            data_manager.query_hidden(sql_delete)
            #ft_point= self.__ft_points[name_point]
            #ft_point.geometry=new_point
            #self.__table.update([ft_point])
            #new_ft_point = Feature({'id': self.__points.activeId}, geometry=new_point, style=self.__def_style)
            #self.__ft_points[name_point] = new_ft_point
            #self.__table.insert([new_ft_point])
        else:
            ''' Создам новую точку '''
            #new_ft_point=Feature({'id':self.__points.activeId},geometry=new_point,style=self.__def_style)
            self.__ft_points[name_point]=new_ft_point
        self.__table.insert([new_ft_point])
    def setActiveId(self,id):
        self.__points.setActiveId(id)
    def countPoints(self):
        return len(list(self.__ft_points.keys()))
    def closeTable(self):
        self.__points.clearAll()
        self.__ft_points = {}
        sql_delete_all="Delete From "+self.__table.name
        #data_manager.query_hidden(sql_delete_all)
        #count=self.__table.count()
        self.__table.undo(1000000)
        self.__table.close()

def createTableAndAddToMap(map_view:MapView,cls_points):
    name="tmp_point_"+map_view.title
    temp_tab_cls=TempRegPoint(name,cls_points,map_view.coordsystem)
    layer_temp=Layer.create(temp_tab_cls.table)
    map_view.map.layers.append(layer_temp)
    moveLayerTo(map_view.map,layer_temp.title,0)
    return temp_tab_cls
