from PySide2.QtCore import QObject, Signal
from PySide2.QtWidgets import QWidget, QLineEdit, QRadioButton, QButtonGroup


def getNumPointEndXY(name_obj):
    att_name=name_obj.split('_')
    if len(att_name)<4:
        return None,None
    return att_name[2],att_name[3]
def getNumPointButton(name_obj):
    att_name=name_obj.split('_')
    if len(att_name)<3:
        return None,None
    return att_name[1],att_name[2]
class CntlPoint:
    def __init__(self,ln_editX,ln_editY):
        self.__lnx=ln_editX
        self.__lny=ln_editY
    def updateXY(self,x:float,y:float):
        self.__lnx.setText(str(x))
        self.__lnx.setCursorPosition(0)
        self.__lny.setText(str(y))
        self.__lny.setCursorPosition(0)
class PointsCntl(QObject):
    #update_pointxy=Signal(int,float,float)
    def __init__(self):
        self.__pointCntl=[]
        self.__id_active=1

    def add(self,point:CntlPoint):
        self.__pointCntl.append(point)
    def setXY(self,x,y):
        #self.update_pointxy.emit(self.__id_active,x,y)
        self.__pointCntl[self.__id_active-1].updateXY(x,y)
    @property
    def activeId(self):
        return self.__id_active
    def setActiveId(self,id):
        self.__id_active=id
    def clearAll(self):
        for pnt in self.__pointCntl:
            pnt.updateXY(0,0)
def factoryClsPoinsValue(parent_widget:QWidget):
    all_lineedits=parent_widget.findChildren(QLineEdit)
    temp_pnt_cls={'1':{},'2':{},'3':{}}
    for w_line_edit in all_lineedits:
        object_name=w_line_edit.objectName()
        name_axis,id=getNumPointEndXY(object_name)
        temp_pnt_cls[id][name_axis]=w_line_edit
    cls_Points=PointsCntl()
    for i in range(1,4):
        sid=str(i)
        pnts_widget=temp_pnt_cls[sid]
        cls_Points.add(CntlPoint(pnts_widget['x'],pnts_widget['y']))
    return cls_Points
def getButtonGroup(parent_widget:QWidget):
    all_QRadioButton = parent_widget.findChildren(QRadioButton)
    btn_grp = QButtonGroup()
    btn_grp.setExclusive(True)
    for button in all_QRadioButton:
        object_name = button.objectName()
        name_axis, id = getNumPointButton(object_name)
        if id is None:
            continue
        btn_grp.addButton(button, id=int(id))
    return btn_grp




